/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200528 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of SSDT-FANREAD.aml, Tue Aug 18 17:05:59 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000002C8 (712)
 *     Revision         0x02
 *     Checksum         0x01
 *     OEM ID           "hack"
 *     OEM Table ID     "_FANREAD"
 *     OEM Revision     0x00000000 (0)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20180427 (538444839)
 */
DefinitionBlock ("", "SSDT", 2, "hack", "_FANREAD", 0x00000000)
{
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.LPCB, DeviceObj)
    External (_SB_.PCI0.LPCB.EC__, DeviceObj)
    External (_SB_.PCI0.LPCB.EC__.CRZN, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC__.DTMP, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC__.ECMX, MutexObj)
    External (_SB_.PCI0.LPCB.EC__.ECRG, IntObj)
    External (_SB_.PCI0.LPCB.EC__.FRDC, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC__.TEMP, FieldUnitObj)

    Device (SMCD)
    {
        Name (_HID, "FAN00000")  // _HID: Hardware ID
        Name (TACH, Package (0x02)
        {
            "System Fan", 
            "FAN0"
        })
        Name (TEMP, Package (0x04)
        {
            "CPU Heatsink", 
            "TCPU", 
            "Ambient", 
            "TAMB"
        })
        Method (FAN0, 0, Serialized)
        {
            If (!\_SB.PCI0.LPCB.EC.ECRG)
            {
                Return (Zero)
            }

            Local0 = \_SB.PCI0.LPCB.EC.FRDC /* External reference */
            If (Local0)
            {
                Local0 = ((0x0003C000 + (Local0 >> One)) / Local0)
            }

            If ((0x03C4 == Local0))
            {
                Return (Zero)
            }

            Return (Local0)
        }

        Method (TCPU, 0, Serialized)
        {
            If (!\_SB.PCI0.LPCB.EC.ECRG)
            {
                Return (Zero)
            }

            Acquire (\_SB.PCI0.LPCB.EC.ECMX, 0xFFFF)
            \_SB.PCI0.LPCB.EC.CRZN = One
            Local0 = \_SB.PCI0.LPCB.EC.DTMP /* External reference */
            Release (\_SB.PCI0.LPCB.EC.ECMX)
            Return (Local0)
        }

        Method (TAMB, 0, Serialized)
        {
            If (!\_SB.PCI0.LPCB.EC.ECRG)
            {
                Return (Zero)
            }

            Acquire (\_SB.PCI0.LPCB.EC.ECMX, 0xFFFF)
            \_SB.PCI0.LPCB.EC.CRZN = 0x04
            Local0 = \_SB.PCI0.LPCB.EC.TEMP /* External reference */
            Release (\_SB.PCI0.LPCB.EC.ECMX)
            Return (Local0)
        }
    }
}

